/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIX509Cert.idl
 */

#ifndef __gen_nsIX509Cert_h__
#define __gen_nsIX509Cert_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIEnumerator_h__
#include "nsIEnumerator.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    nsIX509CertValidity */
#define NS_IX509CERTVALIDITY_IID_STR "e701dfd8-1dd1-11b2-a172-ffa6cc6156ad"

#define NS_IX509CERTVALIDITY_IID \
  {0xe701dfd8, 0x1dd1, 0x11b2, \
    { 0xa1, 0x72, 0xff, 0xa6, 0xcc, 0x61, 0x56, 0xad }}

class NS_NO_VTABLE nsIX509CertValidity : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IX509CERTVALIDITY_IID)

  /* readonly attribute PRTime notBefore; */
  NS_IMETHOD GetNotBefore(PRTime *aNotBefore) = 0;

  /* readonly attribute PRTime notAfter; */
  NS_IMETHOD GetNotAfter(PRTime *aNotAfter) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIX509CERTVALIDITY \
  NS_IMETHOD GetNotBefore(PRTime *aNotBefore); \
  NS_IMETHOD GetNotAfter(PRTime *aNotAfter); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIX509CERTVALIDITY(_to) \
  NS_IMETHOD GetNotBefore(PRTime *aNotBefore) { return _to ## GetNotBefore(aNotBefore); } \
  NS_IMETHOD GetNotAfter(PRTime *aNotAfter) { return _to ## GetNotAfter(aNotAfter); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsX509CertValidity : public nsIX509CertValidity
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIX509CERTVALIDITY

  nsX509CertValidity();
  virtual ~nsX509CertValidity();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsX509CertValidity, nsIX509CertValidity)

nsX509CertValidity::nsX509CertValidity()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsX509CertValidity::~nsX509CertValidity()
{
  /* destructor code */
}

/* readonly attribute PRTime notBefore; */
NS_IMETHODIMP nsX509CertValidity::GetNotBefore(PRTime *aNotBefore)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute PRTime notAfter; */
NS_IMETHODIMP nsX509CertValidity::GetNotAfter(PRTime *aNotAfter)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIX509Cert */
#define NS_IX509CERT_IID_STR "f0980f60-ee3d-11d4-998b-00b0d02354a0"

#define NS_IX509CERT_IID \
  {0xf0980f60, 0xee3d, 0x11d4, \
    { 0x99, 0x8b, 0x00, 0xb0, 0xd0, 0x23, 0x54, 0xa0 }}

class NS_NO_VTABLE nsIX509Cert : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IX509CERT_IID)

  /* readonly attribute wstring nickname; */
  NS_IMETHOD GetNickname(PRUnichar * *aNickname) = 0;

  /* readonly attribute wstring emailAddress; */
  NS_IMETHOD GetEmailAddress(PRUnichar * *aEmailAddress) = 0;

  /* readonly attribute wstring commonName; */
  NS_IMETHOD GetCommonName(PRUnichar * *aCommonName) = 0;

  /* readonly attribute wstring organization; */
  NS_IMETHOD GetOrganization(PRUnichar * *aOrganization) = 0;

  /* readonly attribute wstring organizationalUnit; */
  NS_IMETHOD GetOrganizationalUnit(PRUnichar * *aOrganizationalUnit) = 0;

  /* readonly attribute wstring subjectName; */
  NS_IMETHOD GetSubjectName(PRUnichar * *aSubjectName) = 0;

  /* readonly attribute wstring issuerName; */
  NS_IMETHOD GetIssuerName(PRUnichar * *aIssuerName) = 0;

  /* readonly attribute wstring serialNumber; */
  NS_IMETHOD GetSerialNumber(PRUnichar * *aSerialNumber) = 0;

  /* readonly attribute wstring rsaPubModulus; */
  NS_IMETHOD GetRsaPubModulus(PRUnichar * *aRsaPubModulus) = 0;

  /* readonly attribute wstring sha1Fingerprint; */
  NS_IMETHOD GetSha1Fingerprint(PRUnichar * *aSha1Fingerprint) = 0;

  /* readonly attribute wstring md5Fingerprint; */
  NS_IMETHOD GetMd5Fingerprint(PRUnichar * *aMd5Fingerprint) = 0;

  /* readonly attribute nsIX509CertValidity validity; */
  NS_IMETHOD GetValidity(nsIX509CertValidity * *aValidity) = 0;

  /* readonly attribute string dbKey; */
  NS_IMETHOD GetDbKey(char * *aDbKey) = 0;

  /* readonly attribute string windowTitle; */
  NS_IMETHOD GetWindowTitle(char * *aWindowTitle) = 0;

  enum { UNKNOWN_CERT = 0U };

  enum { CA_CERT = 1U };

  enum { USER_CERT = 2U };

  enum { EMAIL_CERT = 4U };

  enum { SERVER_CERT = 8U };

  enum { VERIFIED_OK = 0U };

  enum { NOT_VERIFIED_UNKNOWN = 1U };

  enum { CERT_REVOKED = 2U };

  enum { CERT_EXPIRED = 4U };

  enum { CERT_NOT_TRUSTED = 8U };

  enum { ISSUER_NOT_TRUSTED = 16U };

  enum { ISSUER_UNKNOWN = 32U };

  enum { INVALID_CA = 64U };

  /* nsIEnumerator getChain (); */
  NS_IMETHOD GetChain(nsIEnumerator **_retval) = 0;

  /* void getUsages (out PRUint32 verified, out PRUint32 count, [array, size_is (count)] out wstring usages); */
  NS_IMETHOD GetUsages(PRUint32 *verified, PRUint32 *count, PRUnichar ***usages) = 0;

  /* void view (); */
  NS_IMETHOD View(void) = 0;

  /* [noscript] unsigned long getRawDER (out charPtr result); */
  NS_IMETHOD GetRawDER(char * *result, PRUint32 *_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIX509CERT \
  NS_IMETHOD GetNickname(PRUnichar * *aNickname); \
  NS_IMETHOD GetEmailAddress(PRUnichar * *aEmailAddress); \
  NS_IMETHOD GetCommonName(PRUnichar * *aCommonName); \
  NS_IMETHOD GetOrganization(PRUnichar * *aOrganization); \
  NS_IMETHOD GetOrganizationalUnit(PRUnichar * *aOrganizationalUnit); \
  NS_IMETHOD GetSubjectName(PRUnichar * *aSubjectName); \
  NS_IMETHOD GetIssuerName(PRUnichar * *aIssuerName); \
  NS_IMETHOD GetSerialNumber(PRUnichar * *aSerialNumber); \
  NS_IMETHOD GetRsaPubModulus(PRUnichar * *aRsaPubModulus); \
  NS_IMETHOD GetSha1Fingerprint(PRUnichar * *aSha1Fingerprint); \
  NS_IMETHOD GetMd5Fingerprint(PRUnichar * *aMd5Fingerprint); \
  NS_IMETHOD GetValidity(nsIX509CertValidity * *aValidity); \
  NS_IMETHOD GetDbKey(char * *aDbKey); \
  NS_IMETHOD GetWindowTitle(char * *aWindowTitle); \
  NS_IMETHOD GetChain(nsIEnumerator **_retval); \
  NS_IMETHOD GetUsages(PRUint32 *verified, PRUint32 *count, PRUnichar ***usages); \
  NS_IMETHOD View(void); \
  NS_IMETHOD GetRawDER(char * *result, PRUint32 *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIX509CERT(_to) \
  NS_IMETHOD GetNickname(PRUnichar * *aNickname) { return _to ## GetNickname(aNickname); } \
  NS_IMETHOD GetEmailAddress(PRUnichar * *aEmailAddress) { return _to ## GetEmailAddress(aEmailAddress); } \
  NS_IMETHOD GetCommonName(PRUnichar * *aCommonName) { return _to ## GetCommonName(aCommonName); } \
  NS_IMETHOD GetOrganization(PRUnichar * *aOrganization) { return _to ## GetOrganization(aOrganization); } \
  NS_IMETHOD GetOrganizationalUnit(PRUnichar * *aOrganizationalUnit) { return _to ## GetOrganizationalUnit(aOrganizationalUnit); } \
  NS_IMETHOD GetSubjectName(PRUnichar * *aSubjectName) { return _to ## GetSubjectName(aSubjectName); } \
  NS_IMETHOD GetIssuerName(PRUnichar * *aIssuerName) { return _to ## GetIssuerName(aIssuerName); } \
  NS_IMETHOD GetSerialNumber(PRUnichar * *aSerialNumber) { return _to ## GetSerialNumber(aSerialNumber); } \
  NS_IMETHOD GetRsaPubModulus(PRUnichar * *aRsaPubModulus) { return _to ## GetRsaPubModulus(aRsaPubModulus); } \
  NS_IMETHOD GetSha1Fingerprint(PRUnichar * *aSha1Fingerprint) { return _to ## GetSha1Fingerprint(aSha1Fingerprint); } \
  NS_IMETHOD GetMd5Fingerprint(PRUnichar * *aMd5Fingerprint) { return _to ## GetMd5Fingerprint(aMd5Fingerprint); } \
  NS_IMETHOD GetValidity(nsIX509CertValidity * *aValidity) { return _to ## GetValidity(aValidity); } \
  NS_IMETHOD GetDbKey(char * *aDbKey) { return _to ## GetDbKey(aDbKey); } \
  NS_IMETHOD GetWindowTitle(char * *aWindowTitle) { return _to ## GetWindowTitle(aWindowTitle); } \
  NS_IMETHOD GetChain(nsIEnumerator **_retval) { return _to ## GetChain(_retval); } \
  NS_IMETHOD GetUsages(PRUint32 *verified, PRUint32 *count, PRUnichar ***usages) { return _to ## GetUsages(verified, count, usages); } \
  NS_IMETHOD View(void) { return _to ## View(); } \
  NS_IMETHOD GetRawDER(char * *result, PRUint32 *_retval) { return _to ## GetRawDER(result, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsX509Cert : public nsIX509Cert
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIX509CERT

  nsX509Cert();
  virtual ~nsX509Cert();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsX509Cert, nsIX509Cert)

nsX509Cert::nsX509Cert()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsX509Cert::~nsX509Cert()
{
  /* destructor code */
}

/* readonly attribute wstring nickname; */
NS_IMETHODIMP nsX509Cert::GetNickname(PRUnichar * *aNickname)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring emailAddress; */
NS_IMETHODIMP nsX509Cert::GetEmailAddress(PRUnichar * *aEmailAddress)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring commonName; */
NS_IMETHODIMP nsX509Cert::GetCommonName(PRUnichar * *aCommonName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring organization; */
NS_IMETHODIMP nsX509Cert::GetOrganization(PRUnichar * *aOrganization)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring organizationalUnit; */
NS_IMETHODIMP nsX509Cert::GetOrganizationalUnit(PRUnichar * *aOrganizationalUnit)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring subjectName; */
NS_IMETHODIMP nsX509Cert::GetSubjectName(PRUnichar * *aSubjectName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring issuerName; */
NS_IMETHODIMP nsX509Cert::GetIssuerName(PRUnichar * *aIssuerName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring serialNumber; */
NS_IMETHODIMP nsX509Cert::GetSerialNumber(PRUnichar * *aSerialNumber)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring rsaPubModulus; */
NS_IMETHODIMP nsX509Cert::GetRsaPubModulus(PRUnichar * *aRsaPubModulus)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring sha1Fingerprint; */
NS_IMETHODIMP nsX509Cert::GetSha1Fingerprint(PRUnichar * *aSha1Fingerprint)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring md5Fingerprint; */
NS_IMETHODIMP nsX509Cert::GetMd5Fingerprint(PRUnichar * *aMd5Fingerprint)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIX509CertValidity validity; */
NS_IMETHODIMP nsX509Cert::GetValidity(nsIX509CertValidity * *aValidity)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute string dbKey; */
NS_IMETHODIMP nsX509Cert::GetDbKey(char * *aDbKey)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute string windowTitle; */
NS_IMETHODIMP nsX509Cert::GetWindowTitle(char * *aWindowTitle)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIEnumerator getChain (); */
NS_IMETHODIMP nsX509Cert::GetChain(nsIEnumerator **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getUsages (out PRUint32 verified, out PRUint32 count, [array, size_is (count)] out wstring usages); */
NS_IMETHODIMP nsX509Cert::GetUsages(PRUint32 *verified, PRUint32 *count, PRUnichar ***usages)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void view (); */
NS_IMETHODIMP nsX509Cert::View()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] unsigned long getRawDER (out charPtr result); */
NS_IMETHODIMP nsX509Cert::GetRawDER(char * *result, PRUint32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif

#define NS_X509CERT_CID { 0xf0980f60, 0xee3d, 0x11d4, \
                         { 0x99, 0x8b, 0x00, 0xb0, 0xd0, 0x23, 0x54, 0xa0 } }
#define NS_X509CERT_CONTRACTID "@mozilla.org/security/x509cert;1"

#endif /* __gen_nsIX509Cert_h__ */
