/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIX509CertDB.idl
 */

#ifndef __gen_nsIX509CertDB_h__
#define __gen_nsIX509CertDB_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
#include "nsString.h"
class nsIX509Cert; /* forward declaration */

class nsIPK11Token; /* forward declaration */

class nsILocalFile; /* forward declaration */


/* starting interface:    nsIX509CertDB */
#define NS_IX509CERTDB_IID_STR "da48b3c0-1284-11d5-ac67-000064657374"

#define NS_IX509CERTDB_IID \
  {0xda48b3c0, 0x1284, 0x11d5, \
    { 0xac, 0x67, 0x00, 0x00, 0x64, 0x65, 0x73, 0x74 }}

class NS_NO_VTABLE nsIX509CertDB : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IX509CERTDB_IID)

  enum { UNTRUSTED = 0U };

  enum { TRUSTED_SSL = 1U };

  enum { TRUSTED_EMAIL = 2U };

  enum { TRUSTED_OBJSIGN = 4U };

  /* nsIX509Cert getCertByNickname (in nsIPK11Token aToken, in wstring aNickname); */
  NS_IMETHOD GetCertByNickname(nsIPK11Token *aToken, const PRUnichar *aNickname, nsIX509Cert **_retval) = 0;

  /* nsIX509Cert getCertByDBKey (in string aDBkey, in nsIPK11Token aToken); */
  NS_IMETHOD GetCertByDBKey(const char *aDBkey, nsIPK11Token *aToken, nsIX509Cert **_retval) = 0;

  /* void getCertNicknames (in nsIPK11Token aToken, in unsigned long aType, out unsigned long count, [array, size_is (count)] out wstring certNameList); */
  NS_IMETHOD GetCertNicknames(nsIPK11Token *aToken, PRUint32 aType, PRUint32 *count, PRUnichar ***certNameList) = 0;

  /* [noscript] void importCertificate (in nsIX509Cert cert, in unsigned long type, in unsigned long trust, in wstring nickname); */
  NS_IMETHOD ImportCertificate(nsIX509Cert *cert, PRUint32 type, PRUint32 trust, const PRUnichar *nickname) = 0;

  /* void deleteCertificate (in nsIX509Cert aCert); */
  NS_IMETHOD DeleteCertificate(nsIX509Cert *aCert) = 0;

  /* void setCertTrust (in nsIX509Cert cert, in unsigned long type, in unsigned long trust); */
  NS_IMETHOD SetCertTrust(nsIX509Cert *cert, PRUint32 type, PRUint32 trust) = 0;

  /* boolean getCertTrust (in nsIX509Cert cert, in unsigned long trustType); */
  NS_IMETHOD GetCertTrust(nsIX509Cert *cert, PRUint32 trustType, PRBool *_retval) = 0;

  /* void importPKCS12File (in nsIPK11Token aToken, in nsILocalFile aFile); */
  NS_IMETHOD ImportPKCS12File(nsIPK11Token *aToken, nsILocalFile *aFile) = 0;

  /* void exportPKCS12File (in nsIPK11Token aToken, in nsILocalFile aFile, in PRUint32 count, [array, size_is (count)] in nsIX509Cert aCerts); */
  NS_IMETHOD ExportPKCS12File(nsIPK11Token *aToken, nsILocalFile *aFile, PRUint32 count, nsIX509Cert **aCerts) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIX509CERTDB \
  NS_IMETHOD GetCertByNickname(nsIPK11Token *aToken, const PRUnichar *aNickname, nsIX509Cert **_retval); \
  NS_IMETHOD GetCertByDBKey(const char *aDBkey, nsIPK11Token *aToken, nsIX509Cert **_retval); \
  NS_IMETHOD GetCertNicknames(nsIPK11Token *aToken, PRUint32 aType, PRUint32 *count, PRUnichar ***certNameList); \
  NS_IMETHOD ImportCertificate(nsIX509Cert *cert, PRUint32 type, PRUint32 trust, const PRUnichar *nickname); \
  NS_IMETHOD DeleteCertificate(nsIX509Cert *aCert); \
  NS_IMETHOD SetCertTrust(nsIX509Cert *cert, PRUint32 type, PRUint32 trust); \
  NS_IMETHOD GetCertTrust(nsIX509Cert *cert, PRUint32 trustType, PRBool *_retval); \
  NS_IMETHOD ImportPKCS12File(nsIPK11Token *aToken, nsILocalFile *aFile); \
  NS_IMETHOD ExportPKCS12File(nsIPK11Token *aToken, nsILocalFile *aFile, PRUint32 count, nsIX509Cert **aCerts); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIX509CERTDB(_to) \
  NS_IMETHOD GetCertByNickname(nsIPK11Token *aToken, const PRUnichar *aNickname, nsIX509Cert **_retval) { return _to ## GetCertByNickname(aToken, aNickname, _retval); } \
  NS_IMETHOD GetCertByDBKey(const char *aDBkey, nsIPK11Token *aToken, nsIX509Cert **_retval) { return _to ## GetCertByDBKey(aDBkey, aToken, _retval); } \
  NS_IMETHOD GetCertNicknames(nsIPK11Token *aToken, PRUint32 aType, PRUint32 *count, PRUnichar ***certNameList) { return _to ## GetCertNicknames(aToken, aType, count, certNameList); } \
  NS_IMETHOD ImportCertificate(nsIX509Cert *cert, PRUint32 type, PRUint32 trust, const PRUnichar *nickname) { return _to ## ImportCertificate(cert, type, trust, nickname); } \
  NS_IMETHOD DeleteCertificate(nsIX509Cert *aCert) { return _to ## DeleteCertificate(aCert); } \
  NS_IMETHOD SetCertTrust(nsIX509Cert *cert, PRUint32 type, PRUint32 trust) { return _to ## SetCertTrust(cert, type, trust); } \
  NS_IMETHOD GetCertTrust(nsIX509Cert *cert, PRUint32 trustType, PRBool *_retval) { return _to ## GetCertTrust(cert, trustType, _retval); } \
  NS_IMETHOD ImportPKCS12File(nsIPK11Token *aToken, nsILocalFile *aFile) { return _to ## ImportPKCS12File(aToken, aFile); } \
  NS_IMETHOD ExportPKCS12File(nsIPK11Token *aToken, nsILocalFile *aFile, PRUint32 count, nsIX509Cert **aCerts) { return _to ## ExportPKCS12File(aToken, aFile, count, aCerts); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsX509CertDB : public nsIX509CertDB
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIX509CERTDB

  nsX509CertDB();
  virtual ~nsX509CertDB();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsX509CertDB, nsIX509CertDB)

nsX509CertDB::nsX509CertDB()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsX509CertDB::~nsX509CertDB()
{
  /* destructor code */
}

/* nsIX509Cert getCertByNickname (in nsIPK11Token aToken, in wstring aNickname); */
NS_IMETHODIMP nsX509CertDB::GetCertByNickname(nsIPK11Token *aToken, const PRUnichar *aNickname, nsIX509Cert **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIX509Cert getCertByDBKey (in string aDBkey, in nsIPK11Token aToken); */
NS_IMETHODIMP nsX509CertDB::GetCertByDBKey(const char *aDBkey, nsIPK11Token *aToken, nsIX509Cert **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getCertNicknames (in nsIPK11Token aToken, in unsigned long aType, out unsigned long count, [array, size_is (count)] out wstring certNameList); */
NS_IMETHODIMP nsX509CertDB::GetCertNicknames(nsIPK11Token *aToken, PRUint32 aType, PRUint32 *count, PRUnichar ***certNameList)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] void importCertificate (in nsIX509Cert cert, in unsigned long type, in unsigned long trust, in wstring nickname); */
NS_IMETHODIMP nsX509CertDB::ImportCertificate(nsIX509Cert *cert, PRUint32 type, PRUint32 trust, const PRUnichar *nickname)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void deleteCertificate (in nsIX509Cert aCert); */
NS_IMETHODIMP nsX509CertDB::DeleteCertificate(nsIX509Cert *aCert)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setCertTrust (in nsIX509Cert cert, in unsigned long type, in unsigned long trust); */
NS_IMETHODIMP nsX509CertDB::SetCertTrust(nsIX509Cert *cert, PRUint32 type, PRUint32 trust)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean getCertTrust (in nsIX509Cert cert, in unsigned long trustType); */
NS_IMETHODIMP nsX509CertDB::GetCertTrust(nsIX509Cert *cert, PRUint32 trustType, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void importPKCS12File (in nsIPK11Token aToken, in nsILocalFile aFile); */
NS_IMETHODIMP nsX509CertDB::ImportPKCS12File(nsIPK11Token *aToken, nsILocalFile *aFile)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void exportPKCS12File (in nsIPK11Token aToken, in nsILocalFile aFile, in PRUint32 count, [array, size_is (count)] in nsIX509Cert aCerts); */
NS_IMETHODIMP nsX509CertDB::ExportPKCS12File(nsIPK11Token *aToken, nsILocalFile *aFile, PRUint32 count, nsIX509Cert **aCerts)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif

#define NS_X509CERTDB_CID { /* da48b3c0-1284-11d5-ac67-000064657374 */ \
    0xda48b3c0,                                                        \
    0x1284,                                                            \
    0x11d5,                                                            \
    {0xac, 0x67, 0x00, 0x00, 0x64, 0x65, 0x73, 0x74}                   \
  }
#define NS_X509CERTDB_CONTRACTID "@mozilla.org/security/x509certdb;1"
#define NS_CERTIFICATEMGR_DATASOURCE_CONTRACTID \
    "@mozilla.org/rdf/datasource;1?name=certificatemgr"

#endif /* __gen_nsIX509CertDB_h__ */
